init python:

    def BossLocationChange(pLocation, pDestination):
        print(pDestination)
        if boss_phase == 1:
            if pDestination == "none":
                return pLocation
            if pDestination == "left":
                return max(boss_player_location-1, -1)
            if pDestination == "right":
                return min(boss_player_location+1, 1)
        else:
            if pDestination == "none":
                return pLocation
            if pDestination == "left":
                return boss_player_location-1
            if pDestination == "right":
                return boss_player_location+1
    
    boss_phase = 1
    boss_sprite = "idle"
    phase1_bullets = []
    ship_moved = False

    phase2_boss_can_attack = True
    phase2_boss_direction = 0

    boss_player_location = 0
    lagging_line_delay = 0.2
    lagging_line = boss_player_location

    boss_max_hp = 10
    boss_hp = boss_max_hp
    boss_hit = 0 # 1 (soft hit) 2 (hard hit)
    boss_hit_cooldown = 0.1

    boss_gameover = False

    ship_open_top = False

    def BossPhase2_Attack():
        global boss_sprite
        global boss_player_location
        global phase2_boss_direction
        if phase2_boss_direction == boss_player_location:
            boss_sprite = "aim"
            Timer(2.0, BossPhase2_Punch).start()
        else:
            phase2_boss_direction = boss_player_location
            phase2_boss_can_attack = True
            Timer(1.0, BossPhase2_Reset).start()
        renpy.restart_interaction()


    def BossPhase2_Punch():
        global boss_sprite
        global boss_gameover
        if boss_hp > 0:
            boss_sprite = "punch"
            renpy.restart_interaction()

            if phase2_boss_direction == boss_player_location:
                boss_gameover = True

            Timer(2.0, BossPhase2_Reset).start()
    

    def BossPhase2_Reset():
        global boss_sprite
        global phase2_boss_can_attack
        boss_sprite = "idle"
        renpy.restart_interaction()

        phase2_boss_can_attack = True

    def BossPhase2_Shoot(): #Boss get shooted
        global boss_hp
        global boss_phase
        global boss_hit

        if boss_hit == 0:
            if boss_sprite == "aim" and phase2_boss_direction == boss_player_location:
                boss_hit = 2
                boss_hp = boss_hp - 1
                # renpy.notify("HIT "+str(boss_hp))
            else:
                boss_hit = 1

            renpy.restart_interaction()

            if boss_hp <= 0:
                return True
            else:
                Timer(boss_hit_cooldown, BossPhase2HitRemove).start()

    def getBossPhase2Side():
        if phase2_boss_direction == boss_player_location:
            return "front"
        elif phase2_boss_direction > boss_player_location:
            return "left"
        return "right"
        
    def BossPhase2HitRemove():
        global boss_hit
        boss_hit = 0
        renpy.restart_interaction()

    def BossPhase1_Attack():
        global boss_sprite
        boss_sprite = "attack"

        phase1_bullets.append({"line": lagging_line})
        print(phase1_bullets)

        renpy.restart_interaction()
        Timer(1.0, BossPhase1_Idle).start()
        Timer(1.5, BossPhase1_RemoveBullet).start()

    def BossPhase1_Idle():
        global boss_sprite
        boss_sprite = "idle"
        renpy.restart_interaction()

        # Timer(3.2, BossPhase1_Attack).start()
    
    def BossPhase1_RemoveBullet():
        global boss_gameover
        print("player_line "+str(boss_player_location))
        if (lagging_line == phase1_bullets[0]["line"] or boss_player_location == phase1_bullets[0]["line"]):
                print(">> HIT!!")
                boss_gameover = True
        phase1_bullets.pop(0)
        renpy.restart_interaction()


    def init_lagging_line():
        Timer(lagging_line_delay, set_lagging_line).start()
    def set_lagging_line():
        global lagging_line
        lagging_line = boss_player_location

screen boss(idle=False):
    if boss_gameover:
        timer 0.02 action [Return(), Jump("game_over")]
    default destination = "none"
    fixed:
        at Transform(perspective=True)
        if boss_phase == 1:
            use boss_phase1(destination, idle)
        elif boss_phase == 2:
            use boss_phase2(destination, idle)
        elif boss_phase == 3:
            use boss_phase3(destination, idle)

    if not idle:
        if boss_phase == 1:
            if boss_player_location < 1:
                use BtnMovementRight()
            if boss_player_location > -1:
                use BtnMovementLeft()
        elif boss_phase == 2:
            if boss_player_location <= phase2_boss_direction:
                use BtnMovementRight()
            if boss_player_location >= phase2_boss_direction:
                use BtnMovementLeft()
            button: ## Fire button
                align (0.5, 0.98)
                action [Function(BossPhase2_Shoot)] #Fire
                frame:
                    background "#3335"
                    hover_background "#3332"
                    xysize (300, 200)

screen boss_phase1(pDestination, idle):
    default previous_location = 0

    if not idle:
        timer 2.0 action [Function(BossPhase1_Attack)] repeat True

        timer 15.0 action [SetVariable("boss_phase", 2), Return()]

        key "K_SPACE" action [SetLocalVariable("previous_location", boss_player_location), SetVariable("boss_player_location", BossLocationChange(boss_player_location, pDestination)), Function(init_lagging_line)]

    add Solid("#ffb3cb"):
        zzoom True
        zpos -200
    fixed:
        at trans_sky_clouds(boss_player_location, previous_location)
        add "boss/CLOUD01.png":
            at trans_cloud(0.2)
            zpos -150
        add "boss/CLOUD02.png":
            at trans_cloud(0.3)
            zpos -150
        add "boss/CLOUD03.png":
            at trans_cloud(0.1)
            xalign 1.0
            xoffset 80
            zpos -150
    add "boss/phase1_[boss_sprite].png":
        align (0.5, 0.0)
        zzoom True
        zpos -100

    for bullet in phase1_bullets:
        add "boss/bullet.png":
            at trans_bullet(), trans_bullet_xoffset(bullet["line"]-boss_player_location)

    fixed:
        at trans_car_move(ship_moved)
        add "cave/CARTOP.png":
            yalign 1.0
        add "cave/CARBOTTOM 01.png"
        add "boss/line_feedback.png":
            xalign 0.5
            yalign 0.72
            at trans_line_feedback(boss_player_location, previous_location)

screen boss_phase2(pDestination, idle):
    default previous_location = 0

    if not idle:
        if phase2_boss_can_attack:
            timer 2.0 action [Function(BossPhase2_Attack), SetVariable("phase2_boss_can_attack", False)] repeat True

        key "K_SPACE" action [SetLocalVariable("previous_location", boss_player_location), SetVariable("boss_player_location", BossLocationChange(boss_player_location, pDestination)), Function(init_lagging_line)]

    add Solid("#ffb3cb"):
        zzoom True
        zpos -200
    fixed:
        at trans_sky_clouds(boss_player_location*2, previous_location), trans_zoom_clouds
        add "boss/CLOUD01.png":
            at trans_cloud(0.2)
            zpos -150
        add "boss/CLOUD02.png":
            at trans_cloud(0.3)
            zpos -150
        add "boss/CLOUD03.png":
            at trans_cloud(0.1)
            xalign 1.0
            xoffset 80
            zpos -150
    add "boss/phase2_"+getBossPhase2Side()+"_[boss_sprite].png":
        align (0.5, 0.0)
        zzoom True
        zpos -100
        at turn_white(0.1 if boss_hit==1 else 0.9 if boss_hit==2 else 0.0)

    fixed:
        at trans_car_move(ship_moved)
        add "cave/CARTOP.png":
            yalign 1.0
        add "carbottom_button_open"
        add "boss/line_feedback.png":
            xalign 0.5
            yalign 0.72
            at trans_line_feedback(boss_player_location, previous_location)
        

screen boss_phase3(pDestination, idle):
    default previous_location = 0
    add Solid("#ffb3cb"):
        zzoom True
        zpos -200
    fixed:
        at trans_sky_clouds(boss_player_location, previous_location), trans_zoom_clouds
        add "boss/CLOUD01.png":
            at trans_cloud(0.2)
            zpos -150
        add "boss/CLOUD02.png":
            at trans_cloud(0.3)
            zpos -150
        add "boss/CLOUD03.png":
            at trans_cloud(0.1)
            xalign 1.0
            xoffset 80
            zpos -150
    add "boss/phase3_idle.png":
        align (0.5, 0.0)
        zzoom True
        zpos -100
        yoffset -70

    fixed:
        at trans_car_move(ship_moved)
        add "cave/CARTOP.png":
            yalign 1.0
            if ship_open_top:
                at trans_car_top_open
        add "cave/CARBOTTOM 03.png"
        add "boss/line_feedback.png":
            xalign 0.5
            yalign 0.72
            at trans_line_feedback(boss_player_location, previous_location)

transform trans_cloud(offset=0.2):
    yoffset 0
    pause offset
    zzoom True
    block:
        ease 2.0+offset yoffset 20
        ease 2.0+offset yoffset 0
        repeat

transform trans_zoom_clouds:
    zoom 1.1

transform trans_bullet():
    align (0.524, 0.32)
    zoom 0.2
    yoffset 0
    
    zpos -100


    parallel:
        easeout 1.5 zpos 1000
    #     easeout 1.5 zoom 1.0
    parallel:
        easeout 1.5 yalign 0.5

transform trans_bullet_xoffset(line_delta):
    easeout 1.5 xoffset 800*line_delta

transform trans_car_move(pMoved):
    anchor (0.5, 0.5)
    pos (0.5, 0.5)
    
    zzoom True
    zpos 1

    rotate 0
    block:
        ease 7.0 rotate 1.1
        ease 7.0 rotate -1.1
        repeat

transform trans_sky_clouds(pDelta, pPreviousDelta):
    xoffset pPreviousDelta*100
    ease 2.0 xoffset pDelta*100

transform trans_line_feedback(pLine, pPreviousLine):
    xoffset pPreviousLine*50
    ease 0.5 xoffset pLine*50

transform trans_car_top_open:
    yoffset 0
    ease 0.5 yoffset 20
    pause 0.2
    ease 2.0 yoffset -1020


image carbottom_button_open:
    "cave/CARBOTTOM 01.png"
    pause 2.0
    "cave/CARBOTTOM 02.png"
    pause 0.2
    "cave/CARBOTTOM 03.png"
    pause 0.2